
/*
 * $Id: ErrorStat.h,v 1.2.6.2 1999/12/19 06:22:27 rousskov Exp $
 *
 *
 * Web Polygraph                        http://polygraph.ircache.net/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1999 by Alex Rousskov and the
 *  University of California, San Diego (UCSD); all rights reserved.
 *
 *  You may copy and distribute VERBATIM copies of this product. 
 *  You may modify your copy for your own use. You must NOT
 *  distribute modified copies. You must NOT publish benchmarking
 *  results based on modified versions.
 *
 *  If you publish any materials derived from or related to Web
 *  Polygraph, you must give a credit reference to the IRCache group.
 *
 *  Web Polygraph is distributed without any warranty, even implied.
 *
 *  Please see the COPYRIGHT file for full details.
 *
 */

#ifndef PG_ERROR_STATISTICS_H
#define PG_ERROR_STATISTICS_H

#include "Array.h"
#include "LogObj.h"

class String;
class ErrorStrTbl;

// detailed error histogram
// see ErrorStrTbl for error strings
class ErrorStat: public Array<int>, public LogObj {
	public:
		ErrorStat(int maxErrNo = 0);

		void reset();
		void maxErrNo(int max);
		
		int maxErrNo() const;
		int totalErrCnt() const;

		void record(int errNo);

		void add(const ErrorStat &s);
		ErrorStat &operator =(const ErrorStat &es);

		virtual OLog &store(OLog &ol) const;
		virtual ILog &load(ILog &il);

		ostream &print(ostream &os, const ErrorStrTbl &tbl, const String &pfx = "") const;
};

#endif
