
/*
 * $Id: IntvlCut.h,v 1.2 1999/09/07 17:47:02 rousskov Exp $
 *
 *
 * Web Polygraph                        http://polygraph.ircache.net/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1999 by Alex Rousskov and the
 *  University of California, San Diego (UCSD); all rights reserved.
 *
 *  You may copy and distribute VERBATIM copies of this product. 
 *  You may modify your copy for your own use. You must NOT
 *  distribute modified copies. You must NOT publish benchmarking
 *  results based on modified versions.
 *
 *  If you publish any materials derived from or related to Web
 *  Polygraph, you must give a credit reference to the IRCache group.
 *
 *  Web Polygraph is distributed without any warranty, even implied.
 *
 *  Please see the COPYRIGHT file for full details.
 *
 */

#ifndef PG_INTERVAL_CUTTER_H
#define PG_INTERVAL_CUTTER_H

// signals the change (border) in equaly spaced time intervals

class IntervalCutter {
	public:
		IntervalCutter();

		void configure(Time anIntvl);

		const Time &eoi() const { return theEoi; }

		// returns true if next interval has started
		bool update(Time curTime);

	protected:
		Time theIntvl;
		Time theEoi;   // the end of the last interval
};

#endif
