
/*
 * $Id: matchAndPrint.h,v 1.1.2.2 1999/12/20 04:39:16 rousskov Exp $
 *
 *
 * Web Polygraph                        http://polygraph.ircache.net/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1999 by Alex Rousskov and the
 *  University of California, San Diego (UCSD); all rights reserved.
 *
 *  You may copy and distribute VERBATIM copies of this product. 
 *  You may modify your copy for your own use. You must NOT
 *  distribute modified copies. You must NOT publish benchmarking
 *  results based on modified versions.
 *
 *  If you publish any materials derived from or related to Web
 *  Polygraph, you must give a credit reference to the IRCache group.
 *
 *  Web Polygraph is distributed without any warranty, even implied.
 *
 *  Please see the COPYRIGHT file for full details.
 *
 */

#ifndef PG_MATCH_AND_PRINT_H
#define PG_MATCH_AND_PRINT_H

class ostream;
class String;

#include "Array.h"

// scans buf for matching objects and prints them
// prints the entire buffer if no names were specified
// retuns number of matches or -1 if no names were specified
extern int MatchAndPrint(ostream &os, const char *buf, const Array<String*> &names);

// same as MatchAndPrint but extracts and prints object bodies only
extern int MatchAndPrintBodies(ostream &os, const char *buf, const Array<String*> &names);

// same as MatchAndPrint but extracts and prints object tags only
extern int MatchAndPrintHeader(ostream &os, const char *buf, const Array<String*> &names);

#endif
