
/*
 * $Id: polyLogTags.h,v 1.5.6.2 1999/10/23 23:00:58 rousskov Exp $
 *
 *
 * Web Polygraph                        http://polygraph.ircache.net/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1999 by Alex Rousskov and the
 *  University of California, San Diego (UCSD); all rights reserved.
 *
 *  You may copy and distribute VERBATIM copies of this product. 
 *  You may modify your copy for your own use. You must NOT
 *  distribute modified copies. You must NOT publish benchmarking
 *  results based on modified versions.
 *
 *  If you publish any materials derived from or related to Web
 *  Polygraph, you must give a credit reference to the IRCache group.
 *
 *  Web Polygraph is distributed without any warranty, even implied.
 *
 *  Please see the COPYRIGHT file for full details.
 *
 */

#ifndef PG_LOG_TAGS_H
#define PG_LOG_TAGS_H

// append-only table with well-known binary log tags
typedef enum { 
	lgNone = 0,

	// special "system" tags
	lgProgress,
	lgComment,
	lgRunId,
	lgEndOfSysTags = 255,

	// user tags
	lgStatCycleRec,
	lgStatPhaseBeg,
	lgStatPhaseEnd,
	lgStatPhaseRec,
	lgErrorStrs,
	lgErrorStat,

	lgAppCfg,
	lgCltCfg,
	lgSrvCfg,
	lgSrvRepCfg,

	lgAppState,
	lgCltState,
	lgSrvState,
	lgSrvRepState,

	lgStatsSmplBeg,
	lgStatsSmplEnd, // not used

	// end marker
	lgEnd
} LogEntryTag;

// magic labels for binary logs (magic labels are not magic numbers!)
typedef enum {
	lgMagic1 = 0x506f6c79,
	lgMagic2 = 0x4c6f672e
} LogMagicLabel;


#endif
