
/*
 * $Id: AgentArrIter.h,v 1.1.2.2 1999/10/31 03:10:06 rousskov Exp $
 *
 *
 * Web Polygraph                        http://polygraph.ircache.net/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1999 by Alex Rousskov and the
 *  University of California, San Diego (UCSD); all rights reserved.
 *
 *  You may copy and distribute VERBATIM copies of this product. 
 *  You may modify your copy for your own use. You must NOT
 *  distribute modified copies. You must NOT publish benchmarking
 *  results based on modified versions.
 *
 *  If you publish any materials derived from or related to Web
 *  Polygraph, you must give a credit reference to the IRCache group.
 *
 *  Web Polygraph is distributed without any warranty, even implied.
 *
 *  Please see the COPYRIGHT file for full details.
 *
 */

#ifndef PG_AGENT_ARRAY_ITERATOR_H
#define PG_AGENT_ARRAY_ITERATOR_H

#include "HostsBasedIter.h"

class AgentSym;

// agent array iterator, based on HostsBasedIter
class AgentArrIter: public HostsBasedIter {
	public:
		typedef Array<AgentSym*> CfgSyms;

	public:
		AgentArrIter(const String &anAgentType);
		AgentArrIter(CfgSyms &aCfgSyms, const Addrs *aLocalAddrs, const String &anAgentType);

		AgentSym *agentSym();

	protected:
		virtual bool belongs(const HostsBasedSym *cfgSym, const NetAddr &host) const;
		HostsBasedSym *cfgSym(int idx) const;
		virtual int cfgCount() const;

	protected:
		CfgSyms theCfgs;
		String theAgentType;  // iterate through agents of this type
};

#endif
