
/*
 * $Id: NetPipeSym.h,v 1.1.2.1 1999/10/31 03:10:11 rousskov Exp $
 *
 *
 * Web Polygraph                        http://polygraph.ircache.net/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1999 by Alex Rousskov and the
 *  University of California, San Diego (UCSD); all rights reserved.
 *
 *  You may copy and distribute VERBATIM copies of this product. 
 *  You may modify your copy for your own use. You must NOT
 *  distribute modified copies. You must NOT publish benchmarking
 *  results based on modified versions.
 *
 *  If you publish any materials derived from or related to Web
 *  Polygraph, you must give a credit reference to the IRCache group.
 *
 *  Web Polygraph is distributed without any warranty, even implied.
 *
 *  Please see the COPYRIGHT file for full details.
 *
 */

#ifndef PGL_NETWORK_PIPE_SYMBOL_H
#define PGL_NETWORK_PIPE_SYMBOL_H

#include "HostsBasedSym.h"

// base class for robot and server symbols
class NetPipeSym: public HostsBasedSym {
	public:
		NetPipeSym();
		NetPipeSym(const String &aType, PglRec *aRec);

		virtual bool isA(const String &type) const;
		virtual SynSym *clone(const String &type) const;

		String kind() const;
		bool bandwidthBitsps(int &bps) const;
		bool queuePacketSize(int &size) const;
		bool queueByteSize(int &size) const;
		bool packetLoss(double &plr) const;
		RndDistr *packetDelay() const;
		bool incoming() const;
		bool outgoing() const;
};

#endif
