
/*
 * $Id: PglDistrSym.h,v 1.6 1999/09/07 17:48:02 rousskov Exp $
 *
 *
 * Web Polygraph                        http://polygraph.ircache.net/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1999 by Alex Rousskov and the
 *  University of California, San Diego (UCSD); all rights reserved.
 *
 *  You may copy and distribute VERBATIM copies of this product. 
 *  You may modify your copy for your own use. You must NOT
 *  distribute modified copies. You must NOT publish benchmarking
 *  results based on modified versions.
 *
 *  If you publish any materials derived from or related to Web
 *  Polygraph, you must give a credit reference to the IRCache group.
 *
 *  Web Polygraph is distributed without any warranty, even implied.
 *
 *  Please see the COPYRIGHT file for full details.
 *
 */

#ifndef PGL_DISTRIBUTION_SYMBOL_H
#define PGL_DISTRIBUTION_SYMBOL_H

#include "PglExprSym.h"

class String;
class RndDistr;
class QualifSym;

// a distribution with an optional qualifier

class DistrSym: public ExpressionSym {
	public:
		DistrSym(const String &aType, RndDistr *aVal);
		virtual ~DistrSym();

		virtual bool isA(const String &type) const;
		virtual SynSym *clone(const String &type) const;

		RndDistr *val() const { return theVal; }

		void qualifier(const QualifSym *aQual, const String &anOp);
		QualifSym *qualifier() const { return theQual; }
		const String &qfOp() const { return theQfOp; }

		virtual ostream &print(ostream &os, const String &pfx = 0) const;

	protected:
		mutable RndDistr *theVal;
		QualifSym *theQual; // qualifier
		String theQfOp;     // qualifier operator
};

#endif
